import readdir from 'readdir-cluster'
import validFilename from 'valid-filename'
/** Iterator for readdir-cluster that validates the paths using valid-filename */
export function validator(fullPath, relativePath) {
	const valid = validFilename(relativePath)
	if (!valid) {
		this.push(fullPath)
	}
}
/** Validate a directory and its descendants */
export default function validate(fullPath) {
	return new Promise(function (resolve, reject) {
		const invalidPaths = []
		readdir(fullPath, validator.bind(invalidPaths), function (err) {
			if (err) {
				return reject(err)
			} else if (invalidPaths.length) {
				return resolve([false, invalidPaths])
			} else {
				return resolve([true])
			}
		})
	})
}
