'use strict'
var __importDefault =
	(this && this.__importDefault) ||
	function (mod) {
		return mod && mod.__esModule ? mod : { default: mod }
	}
Object.defineProperty(exports, '__esModule', { value: true })
exports.validator = void 0
const readdir_cluster_1 = __importDefault(require('readdir-cluster'))
const valid_filename_1 = __importDefault(require('valid-filename'))
/** Iterator for readdir-cluster that validates the paths using valid-filename */
function validator(fullPath, relativePath) {
	const valid = valid_filename_1.default(relativePath)
	if (!valid) {
		this.push(fullPath)
	}
}
exports.validator = validator
/** Validate a directory and its descendants */
function validate(fullPath) {
	return new Promise(function (resolve, reject) {
		const invalidPaths = []
		readdir_cluster_1.default(fullPath, validator.bind(invalidPaths), function (
			err
		) {
			if (err) {
				return reject(err)
			} else if (invalidPaths.length) {
				return resolve([false, invalidPaths])
			} else {
				return resolve([true])
			}
		})
	})
}
exports.default = validate
